'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-ceff47a0.js');
const index_esm = require('./index.esm-dabee792.js');
const reduxStore_service = require('./redux-store.service-3111cc7b.js');
require('./index.esm-f8fcb5de.js');
require('./index.esm-14e02657.js');

const BpSdkMessageContainer = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.handleSubscriptions = () => {
            this.storeUnsubscribe && this.storeUnsubscribe();
            this.storeUnsubscribe = reduxStore_service.store.mapStateToProps(this, this.mapStateToProps);
        };
        this.mapStateToProps = (state) => {
            return {
                messages: index_esm.kS(state),
            };
        };
        this.messages = undefined;
        this.useExternal = false;
        this.lastMessage = undefined;
    }
    resetState() { }
    connectedCallback() {
        this.resetState();
        this.handleSubscriptions();
    }
    componentWillLoad() {
        this.useExternal = !!customElements.get('bp-sdk-external-message-container');
        customElements.whenDefined('bp-sdk-external-message-container').then(() => {
            this.useExternal = true;
        });
        this.handleSubscriptions();
    }
    handleMessagesUpdate(messages) {
        this.lastMessage = messages[this.messages.length - 1];
    }
    disconnectedCallback() {
        this.storeUnsubscribe && this.storeUnsubscribe();
    }
    componentWillUpdate() {
        this.handleSubscriptions();
    }
    render() {
        return [
            this.useExternal && this.renderExternal(),
            !this.useExternal && this.renderInternal(),
        ];
    }
    renderExternal() {
        return index.h("bp-sdk-external-message-container", { messages: this.messages });
    }
    renderInternal() {
        return this.lastMessage && index.h("bp-sdk-message", { message: this.lastMessage });
    }
    get el() { return index.getElement(this); }
    static get watchers() { return {
        "messages": ["handleMessagesUpdate"]
    }; }
};

exports.bp_sdk_message_container = BpSdkMessageContainer;
