import { newSpecPage } from "@stencil/core/testing";
import { BpSdkBackButton } from "./bp-sdk-back-button";
import { BpSdkButton } from "../bp-sdk-button/bp-sdk-button";
const setupPage = async () => {
    return await newSpecPage({
        html: '<bp-sdk-back-button></bp-sdk-back-button>',
        components: [BpSdkBackButton, BpSdkButton],
    });
};
describe('bp-sdk-back-button', () => {
    it('renders', async () => {
        const page = await setupPage();
        await page.waitForChanges();
        const element = page.root.querySelector('div');
        expect(element).toBeTruthy();
        expect(page.root.querySelector('bp-sdk-external-back-button')).toBeFalsy();
        page.rootInstance.navigateBack.emit = jest.fn();
        const button = page.root
            .querySelector('bp-sdk-button')
            .querySelector('.bp-sdk-button');
        button.click();
        expect(page.rootInstance.navigateBack.emit).toHaveBeenCalledTimes(1);
    });
    it('renders external component if defined', async () => {
        const whenDefinedMock = jest
            .spyOn(customElements, 'whenDefined')
            .mockResolvedValueOnce({});
        const page = await setupPage();
        await page.waitForChanges();
        expect(page.root.querySelector('bp-sdk-external-back-button')).toBeTruthy();
        whenDefinedMock.mockRestore();
    });
});
