import { getStore, setWebSocketConfig, } from "@boldpenguin/sdk-redux";
import { h } from "@stencil/core";
export class BpSdkRoot {
    constructor() {
        this.completedAt = undefined;
        this.disableWebSocket = false;
        this.enableLifecycleEvents = false;
        this.disableToolbar = false;
        this.storeLoaded = false;
    }
    onDisabledWebSocket(disableWebSocket) {
        getStore().dispatch(setWebSocketConfig({ enableWebsocket: !disableWebSocket }));
    }
    resetState() { }
    connectedCallback() {
        this.resetState();
    }
    componentWillLoad() {
        this.onDisabledWebSocket(this.disableWebSocket);
    }
    render() {
        return (h("bp-sdk-setup-container", { key: '2d9c3658704929a698eb1b872d667d47d13b4807' }, h("bp-sdk-queue-container", { key: '5999b65629569f5b4eb5946874598b2776e797a4' }), [
            !!this.enableLifecycleEvents && h("bp-sdk-custom-event-container", { key: 'd4c6868326b35ce6643c01a5d40634875c1c2453' }),
            !this.disableToolbar && h("bp-sdk-interview-toolbar", { key: '86db346d7113efc2879a5dec52b990fddda88890' }),
        ], h("slot", { key: 'd96dcc963622be806f4a925de77ef89a9e9a96fb' })));
    }
    static get is() { return "bp-sdk-root"; }
    static get properties() {
        return {
            "completedAt": {
                "type": "unknown",
                "mutable": true,
                "complexType": {
                    "original": "Date",
                    "resolved": "Date",
                    "references": {
                        "Date": {
                            "location": "global",
                            "id": "global::Date"
                        }
                    }
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": ""
                }
            },
            "disableWebSocket": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "Disable web socket"
                },
                "attribute": "disable-web-socket",
                "reflect": false,
                "defaultValue": "false"
            },
            "enableLifecycleEvents": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "Disable lifecycle events, false by default"
                },
                "attribute": "enable-lifecycle-events",
                "reflect": false,
                "defaultValue": "false"
            },
            "disableToolbar": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "Disable toolbar"
                },
                "attribute": "disable-toolbar",
                "reflect": false,
                "defaultValue": "false"
            }
        };
    }
    static get states() {
        return {
            "storeLoaded": {}
        };
    }
    static get watchers() {
        return [{
                "propName": "disableWebSocket",
                "methodName": "onDisabledWebSocket"
            }];
    }
}
