import { IAnswer, IMappedQuestionGroupAnswers, IQuestionGroupComponent, IQuestionPool } from '@boldpenguin/sdk-types';
import { Unsubscribe } from '@reduxjs/toolkit';
import { BpSdkStore } from '@boldpenguin/sdk-redux';
export declare class BpSdkQuestionGroup implements IQuestionGroupComponent {
    storeUnsubscribe?: Unsubscribe;
    /**
     * answers in group
     */
    answers: IAnswer[];
    /**
     * Classes for styling group
     */
    classes: string;
    /**
     * Group label
     */
    label: string;
    /**
     * Label id's for group
     */
    labelId: string;
    /**
     * Question Group
     */
    questionGroup: IMappedQuestionGroupAnswers;
    /**
     * group type
     */
    type: string;
    questionPools: IQuestionPool[];
    useExternal: boolean;
    resetState(): void;
    connectedCallback(): void;
    componentWillLoad(): void;
    handleSubscriptions: () => void;
    mapStateToProps: (state: BpSdkStore) => {
        questionPools: IQuestionPool[];
    };
    render(): any[];
    renderUnknownGroupType(answer: IAnswer): any[];
    renderExternal(): any;
    hideNestedGroup(group: Map<string, IMappedQuestionGroupAnswers>): boolean;
    shouldRenderLabel(): boolean;
    hideQuestionGroup(): boolean;
    getLabelledBy(): string;
    renderInternal(): any[];
    renderContent(): any;
}
