import { IAnswer, IQuestion, QuestionFieldType } from '@boldpenguin/sdk-types';
export declare class MockQuestion implements IQuestion {
    autocomplete: boolean;
    choices: any[];
    code: string;
    created_at: Date;
    error_text: string;
    field_type: QuestionFieldType;
    help_text: string;
    id: string;
    is_active: boolean;
    is_hidden: boolean;
    is_sensitive: boolean;
    min_date: Date;
    min_value: number;
    max_date: Date;
    max_value: number;
    multiple: boolean;
    order: number;
    placeholder: string;
    pattern: string;
    question_group_id: string;
    question_set_id: string;
    question_pool_id: any;
    reference_type: any;
    required: boolean;
    tags: ['some tag'];
    text: string;
    trackable: boolean;
    updated_at: Date;
}
export declare class MockAnswer implements IAnswer {
    answer_pool_id: string;
    answered_by_consumer: boolean;
    answered_by_source: any;
    answered_by_user: boolean;
    active: boolean;
    application_form_id: string;
    choice_id: string;
    choice_ids: string[];
    created_at: Date;
    display_type: "public";
    errors: {};
    id: string;
    is_completed: boolean;
    is_readonly: boolean;
    parent_answer_pool_id: string;
    question: MockQuestion;
    required: boolean;
    updated_at: Date;
    value: string;
    version: number;
}
export declare const mockQuestionBuilder: (buildTimeConfig?: import("@jackfranklin/test-data-bot").BuildTimeConfig<{
    autocomplete: unknown;
    choices: unknown;
    code: unknown;
    created_at: unknown;
    deactivated: unknown;
    error_text: unknown;
    field_type: unknown;
    help_text: unknown;
    id: unknown;
    is_active: unknown;
    is_hidden: unknown;
    is_sensitive: unknown;
    max_date: unknown;
    max_value: unknown;
    min_date: unknown;
    min_value: unknown;
    multiple: unknown;
    order: unknown;
    pattern: unknown;
    placeholder: unknown;
    question_group_id: unknown;
    question_pool_id: unknown;
    question_set_id: unknown;
    reference_type: unknown;
    required: unknown;
    text: unknown;
    trackable: unknown;
    updated_at: unknown;
}>) => {
    autocomplete: unknown;
    choices: unknown;
    code: unknown;
    created_at: unknown;
    deactivated: unknown;
    error_text: unknown;
    field_type: unknown;
    help_text: unknown;
    id: unknown;
    is_active: unknown;
    is_hidden: unknown;
    is_sensitive: unknown;
    max_date: unknown;
    max_value: unknown;
    min_date: unknown;
    min_value: unknown;
    multiple: unknown;
    order: unknown;
    pattern: unknown;
    placeholder: unknown;
    question_group_id: unknown;
    question_pool_id: unknown;
    question_set_id: unknown;
    reference_type: unknown;
    required: unknown;
    text: unknown;
    trackable: unknown;
    updated_at: unknown;
};
export declare const mockAnswerBuilder: (buildTimeConfig?: import("@jackfranklin/test-data-bot").BuildTimeConfig<{
    active: unknown;
    answer_pool_id: unknown;
    answered_by_consumer: unknown;
    answered_by_source: unknown;
    answered_by_user: unknown;
    application_form_id: unknown;
    choice_id: unknown;
    choice_ids: unknown;
    created_at: unknown;
    display_type: unknown;
    errors: unknown;
    id: unknown;
    is_completed: unknown;
    is_readonly: unknown;
    parent_answer_pool_id: unknown;
    question: unknown;
    required: unknown;
    updated_at: unknown;
    value: unknown;
    version: unknown;
}>) => {
    active: unknown;
    answer_pool_id: unknown;
    answered_by_consumer: unknown;
    answered_by_source: unknown;
    answered_by_user: unknown;
    application_form_id: unknown;
    choice_id: unknown;
    choice_ids: unknown;
    created_at: unknown;
    display_type: unknown;
    errors: unknown;
    id: unknown;
    is_completed: unknown;
    is_readonly: unknown;
    parent_answer_pool_id: unknown;
    question: unknown;
    required: unknown;
    updated_at: unknown;
    value: unknown;
    version: unknown;
};
export declare const mockQuestion: IQuestion;
export declare const mockAnswer: IAnswer;
